diff --git a/hubs/static/client/app/components/Spinner/index.js b/hubs/static/client/app/components/Spinner/index.js
new file mode 100644
index 0000000..4979621
--- /dev/null
+++ b/hubs/static/client/app/components/Spinner/index.js
@@ -0,0 +1,31 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import "./Spinner.css";
+import SpinnerImg from "./spinner.gif";
+import SpinnerCircleImg from "./spinner-circle.gif";
+
+
+export default class Spinner extends React.Component {
+
+  render() {
+    let img, className;
+    if (this.props.circle) {
+      className = "SpinnerCircle";
+      img = SpinnerCircleImg;
+    } else {
+      className = "Spinner";
+      img = SpinnerImg;
+    }
+    return (
+      <div className={className}>
+        <img src={img} />
+      </div>
+    );
+  }
+}
+Spinner.propTypes = {
+  circle: PropTypes.bool
+}
+Spinner.defaultProps = {
+  circle: false
+}
diff --git a/hubs/static/client/app/components/Streams.js b/hubs/static/client/app/components/Streams.js
new file mode 100644
index 0000000..b2b0ff3
--- /dev/null
+++ b/hubs/static/client/app/components/Streams.js
@@ -0,0 +1,193 @@
+import React from 'react';
+import { connect } from 'react-redux';
+import {
+  defineMessages,
+  FormattedMessage,
+  } from 'react-intl';
+import {
+  streamWillUpdate,
+  streamDidUpdate,
+  } from "../core/actions/stream";
+import SSESource from "./SSESource";
+import TabSet from '../components/TabSet';
+import ItemsGetter from '../components/feed/ItemsGetter';
+import Feed from '../components/feed/Feed';
+
+
+class Streams extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      notifItems: [],
+      savedItems: [],
+    };
+    this.handleStreamData = this.handleStreamData.bind(this);
+    this.handleStreamRequestStart = this.handleStreamRequestStart.bind(this);
+    this.handleSavedData = this.handleSavedData.bind(this);
+    this.handleSave = this.handleSave.bind(this);
+    this.handleUnsave = this.handleUnsave.bind(this);
+  }
+
+  handleStreamData(data) {
+    this.setState({
+      notifItems: data
+    },
+      () => (
+        this.props.dispatch(streamDidUpdate())
+      )
+    );
+  }
+
+  handleStreamRequestStart() {
+    this.props.dispatch(streamWillUpdate());
+  }
+
+  handleSavedData(data) {
+    this.setState({savedItems: data});
+  }
+
+  handleSave(item) {
+    if (!this.props.savedUrl) { return; }
+    const payload = {
+      link: item.link,
+      markup: item.markup,
+      secondary_icon: item.secondary_icon,
+      dom_id: item.dom_id,
+    };
+    $.ajax({
+      type: 'POST',
+      url: this.props.savedUrl,
+      data: JSON.stringify(payload),
+      contentType: 'application/json',
+      success: (data) => {
+        this.setState((prevState, props) => {
+          prevState.savedItems.push(data.data);
+          return {savedItems: prevState.savedItems};
+        });
+      },
+    });
+  }
+
+  handleUnsave(item) {
+    if (!this.props.savedUrl) { return; }
+    var updateSavedItems = (item) => {
+      this.setState((prevState, props) => {
+        var items = prevState.savedItems.filter(
+          (currentItem) => (currentItem.dom_id !== item.dom_id)
+        );
+        return {savedItems: items};
+      });
+    };
+    if (item.idx) {
+      // Already saved
+      $.ajax({
+        type: 'DELETE',
+        url: `${this.props.savedUrl}${item.idx}/`,
+        success: () => { updateSavedItems(item) },
+      });
+    } else {
+      updateSavedItems(item);
+    }
+  }
+
+  render() {
+    // Add saved state.
+    var savedItemsIds = this.state.savedItems.map((item) => {
+      return item.dom_id;
+    });
+    var notifs = this.state.notifItems.map((item) => {
+      item.saved = (savedItemsIds.indexOf(item.dom_id) !== -1);
+      return item;
+    });
+
+    return (
+      <div className="Streams">
+        <TabSet tabListClass="mb-3">
+          <FeedPanel
+            username={this.props.username}
+            tabTitle="My Stream"
+            >
+            <ItemsGetter
+              url={this.props.notificationsUrl}
+              useSSE={true}
+              handleData={this.handleStreamData}
+              needsUpdate={false}
+              >
+              <Feed
+                items={notifs}
+                handleSave={this.handleSave}
+                handleUnsave={this.handleUnsave}
+                />
+            </ItemsGetter>
+          </FeedPanel>
+          <FeedPanel
+            username={this.props.username}
+            tabTitle="My Actions"
+            >
+            <Feed
+              items={this.state.notifItems}
+              />
+          </FeedPanel>
+          <FeedPanel
+            username={this.props.username}
+            tabTitle="Saved Notifications"
+            >
+            <ItemsGetter
+              url={this.props.savedUrl}
+              handleData={this.handleSavedData}
+              useSSE={false}
+              >
+              <Feed
+                items={this.state.savedItems}
+                handleUnsave={this.handleUnsave}
+                />
+            </ItemsGetter>
+          </FeedPanel>
+        </TabSet>
+
+        <SSESource />
+      </div>
+    );
+  }
+}
+
+
+const mapStateToProps = (state) => {
+  return {
+    savedUrl: state.urls.saved,
+    notificationsUrl: state.urls.notifications,
+    username: state.currentUser.nickname,
+  }
+};
+
+export default connect(mapStateToProps)(Streams);
+
+
+
+class FeedPanel extends React.Component {
+
+  render() {
+    const filters_url = `https://apps.fedoraproject.org/notifications/${this.props.username}.id.fedoraproject.org/`;
+
+    return (
+      <div>
+        <div className="input-group">
+          <input
+            type="search" className="form-control"
+            placeholder="Search this activity stream..."
+            aria-describedby="searchform-addon" />
+          <span className="input-group-addon">
+            <span><i className="fa fa-search" aria-hidden="true"></i></span>
+          </span>
+        </div>
+        <br/>
+        <div className="alert alert-warning" role="alert">
+          This stream is filtered. <a href={filters_url} target="_blank">View Filters</a>
+        </div>
+        {this.props.children}
+      </div>
+    );
+  }
+
+}
diff --git a/hubs/static/client/app/components/StreamsHeader.js b/hubs/static/client/app/components/StreamsHeader.js
new file mode 100644
index 0000000..7a6900f
--- /dev/null
+++ b/hubs/static/client/app/components/StreamsHeader.js
@@ -0,0 +1,15 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+
+
+export default class StreamsHeader extends React.Component {
+
+  render() {
+    return (
+      <div className="StreamsHeader">
+        <h1>My Stream</h1>
+        <p>Notifications, actions, and other things of interest to me</p>
+      </div>
+    );
+  }
+}
diff --git a/hubs/static/client/app/components/StreamsPage.js b/hubs/static/client/app/components/StreamsPage.js
new file mode 100644
index 0000000..3206280
--- /dev/null
+++ b/hubs/static/client/app/components/StreamsPage.js
@@ -0,0 +1,28 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import { connect } from 'react-redux';
+import {
+  defineMessages,
+  FormattedMessage,
+  } from 'react-intl';
+import PageStructure from './PageStructure';
+import StreamsHeader from './StreamsHeader';
+import Streams from './Streams';
+
+
+export default class StreamsPage extends React.Component {
+
+  render() {
+    return (
+      <PageStructure
+        cssClass="StreamsPage"
+        header={
+          <StreamsHeader />
+        }
+        content={
+          <Streams />
+        }
+        />
+    );
+  }
+}
diff --git a/hubs/static/client/app/components/Tab.js b/hubs/static/client/app/components/Tab.js
new file mode 100644
index 0000000..1084065
--- /dev/null
+++ b/hubs/static/client/app/components/Tab.js
@@ -0,0 +1,27 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+
+
+export default class Tab extends React.Component {
+  render() {
+    var linkClass = `nav-link ${this.props.tabLinkClass}`;
+    if (this.props.active) { linkClass += " active"; }
+    return (
+      <li className="nav-item">
+        <a href="#" role="tab"
+           className={linkClass}
+           onClick={this.props.linkClicked}
+           >
+          {this.props.children}
+        </a>
+      </li>
+    );
+  }
+}
+
+Tab.propTypes = {
+  tabLinkClass: PropTypes.string,
+};
+Tab.defaultProps = {
+  tabLinkClass: '',
+};
diff --git a/hubs/static/client/app/components/TabPanel.js b/hubs/static/client/app/components/TabPanel.js
new file mode 100644
index 0000000..a72dcee
--- /dev/null
+++ b/hubs/static/client/app/components/TabPanel.js
@@ -0,0 +1,13 @@
+import React from 'react';
+
+
+export default class TabPanel extends React.Component {
+  render() {
+    return (
+      <div role="tabpanel"
+           className={"tab-pane" + (this.props.active ? " active" : "")}>
+        {this.props.children}
+      </div>
+    );
+  }
+}
diff --git a/hubs/static/client/app/components/TabSet.js b/hubs/static/client/app/components/TabSet.js
new file mode 100644
index 0000000..25dad18
--- /dev/null
+++ b/hubs/static/client/app/components/TabSet.js
@@ -0,0 +1,71 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import Tab from './Tab';
+import TabPanel from './TabPanel';
+
+
+export default class TabSet extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      activeTab: 0
+    }
+  }
+
+  linkClicked(e, index) {
+    e.preventDefault();
+    this.setState({activeTab: index});
+  }
+
+  render() {
+    var tabLinks = this.props.children.map(function(panel, index) {
+      return (
+        <Tab active={this.state.activeTab === index}
+             linkClicked={(e) => this.linkClicked(e, index)}
+             key={index.toString()}>
+          {panel.props.tabTitle}
+        </Tab>
+        );
+    }.bind(this));
+
+    var tabPanels = this.props.children.map(function(panel, index) {
+      return (
+        <TabPanel
+          active={this.state.activeTab === index}
+          key={index.toString()}>
+          {panel}
+        </TabPanel>
+        );
+    }.bind(this));
+
+    return (
+      <div {...this.props.tabWrapperProps}>
+        <ul role="tablist"
+            className={`nav nav-${this.props.tabType} ${this.props.tabListClass}`}
+            >
+          {tabLinks}
+        </ul>
+        <div
+          className={"tab-content " + this.props.tabContentClass}
+          >
+          {tabPanels}
+        </div>
+      </div>
+    );
+  }
+
+}
+
+TabSet.propTypes = {
+  tabWrapperProps: PropTypes.object,
+  tabType: PropTypes.string,
+  tabListClass: PropTypes.string,
+  tabContentClass: PropTypes.string,
+};
+TabSet.defaultProps = {
+  tabWrapperProps: {},
+  tabType: 'tabs',
+  tabListClass: '',
+  tabContentClass: '',
+};
diff --git a/hubs/static/client/app/components/VisibilitySelect.js b/hubs/static/client/app/components/VisibilitySelect.js
new file mode 100644
index 0000000..7eedaa1
--- /dev/null
+++ b/hubs/static/client/app/components/VisibilitySelect.js
@@ -0,0 +1,40 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+
+
+export default class VisibilitySelect extends React.Component {
+
+  propTypes: {
+    selectedVisibility: PropTypes.string.isRequired,
+    setConfig: PropTypes.func.isRequired,
+  }
+
+  constructor(props) {
+    super(props);
+    this.handleChange = this.handleChange.bind(this);
+  }
+
+  handleChange(e) {
+    this.props.setConfig(e.target.name, e.target.value);
+  }
+
+  render() {
+    return (
+      <fieldset className="form-group">
+        <label htmlFor="visibility">Visibility:</label>
+        <select
+          className="form-control"
+          name="visibility"
+          value={this.props.selectedVisibility || "public"}
+          onChange={this.handleChange}
+          >
+          <option value="public">Public</option>
+          <option value="restricted">Restricted</option>
+        </select>
+        <small className="text-muted">
+          Restricted widgets will only be visible by logged-in users.
+        </small>
+      </fieldset>
+    );
+  }
+}
diff --git a/hubs/static/client/app/components/Widget.js b/hubs/static/client/app/components/Widget.js
new file mode 100644
index 0000000..880c1c4
--- /dev/null
+++ b/hubs/static/client/app/components/Widget.js
@@ -0,0 +1,74 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import { connect } from 'react-redux';
+import {
+  makeLoadable,
+  makeLoadingComponent
+} from '../core/utils';
+import SimpleWidget from '../components/SimpleWidget';
+
+/*
+import HalpWidget from '../widgets/halp/Widget';
+import FeedWidget from '../widgets/feed/Widget';
+*/
+
+
+class Widget extends React.PureComponent {
+
+  propTypes: {
+    widget: PropTypes.array.isRequired,
+    editMode: PropTypes.bool,
+    needsUpdate: PropTypes.bool,
+  }
+  defaultProps: {
+    editMode: false,
+    needsUpdate: false,
+  }
+
+  render() {
+    let widgetComponent;
+    if (!this.props.editMode && this.props.widget.isReact) {
+      const AsyncComponent = makeLoadable(
+        () => import(`../widgets/${this.props.widget.component}/Widget`),
+        makeLoadingComponent(
+          "Loading widget...",
+          "Sorry, there was a problem loading the widget."
+        )
+      );
+      /*
+      console.log(this.props.widget);
+      let AsyncComponent = null;
+      if (this.props.widget.component === "halp") { AsyncComponent = HalpWidget; }
+      if (this.props.widget.component === "feed") { AsyncComponent = FeedWidget; }
+      */
+      widgetComponent = (
+        <AsyncComponent {...this.props} />
+      );
+    } else {
+      widgetComponent = (
+        <SimpleWidget {...this.props} />
+      );
+    }
+    return (
+      <div
+        key={this.props.widget.idx}
+        id={`widget-${this.props.widget.idx}`}
+        className={"widget" + (this.props.editMode ? " widget-edit" : "")}
+        >
+        {widgetComponent}
+      </div>
+    );
+  }
+}
+
+
+const mapStateToProps = (state, ownProps) => {
+  return {
+    editMode: state.ui.widgetsEditMode,
+    needsUpdate: (
+      state.entities.widgets.needUpdate.indexOf(ownProps.widget.idx) !== -1
+    ),
+  }
+};
+
+export default connect(mapStateToProps)(Widget);
diff --git a/hubs/static/client/app/components/WidgetChrome.js b/hubs/static/client/app/components/WidgetChrome.js
new file mode 100644
index 0000000..374b610
--- /dev/null
+++ b/hubs/static/client/app/components/WidgetChrome.js
@@ -0,0 +1,83 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import { connect } from 'react-redux';
+import { openConfigDialog } from "../core/actions/widget";
+import "./WidgetChrome.css";
+
+
+class WidgetChrome extends React.PureComponent {
+
+  propTypes: {
+    widget: PropTypes.object.isRequired,
+    editMode: PropTypes.bool,
+  }
+  defaultProps: {
+    editMode: false,
+  }
+
+  constructor(props) {
+    super(props);
+    this.handleEditButtonClicked = this.handleEditButtonClicked.bind(this)
+  }
+
+  handleEditButtonClicked(e) {
+    e.preventDefault();
+    this.props.onEdit(this.props.widget.idx);
+  }
+
+  render() {
+    const title = (this.props.editMode && !this.props.widget.title) ? this.props.widget.label : this.props.widget.title;
+    let cssClass = `WidgetChrome card widget-${this.props.widget.name}`;
+    if (this.props.widget.cssClass) {
+      cssClass += " " + this.props.widget.cssClass;
+    }
+    return (
+      <div className={cssClass}>
+        <div className="widget-buttons">
+          { this.props.editMode &&
+            <a href="#"
+              onClick={this.handleEditButtonClicked}
+              >
+              <i className="fa fa-cog" aria-hidden="true"></i>
+            </a>
+          }
+        </div>
+        { title ?
+          <div className="card-header">
+            {title}
+          </div>
+          : null
+        }
+        <div className="card-block">
+          { this.props.editMode &&
+            <div className="text-muted">Content hidden in edit mode</div>
+            ||
+            this.props.children
+          }
+        </div>
+        { this.props.widget.footer ?
+          <div className="card-footer">
+            {this.props.widget.footer}
+          </div>
+          : null
+        }
+      </div>
+    );
+  }
+}
+
+
+const mapStateToProps = (state) => {
+  return {
+    editMode: state.ui.widgetsEditMode,
+  }
+};
+const mapDispatchToProps = dispatch => {
+  return {
+    onEdit: (widgetId) => { dispatch(openConfigDialog(widgetId)); }
+  }
+}
+
+export default connect(
+  mapStateToProps, mapDispatchToProps
+  )(WidgetChrome);
diff --git a/hubs/static/client/app/components/WidgetConfigDialog.js b/hubs/static/client/app/components/WidgetConfigDialog.js
new file mode 100644
index 0000000..1548956
--- /dev/null
+++ b/hubs/static/client/app/components/WidgetConfigDialog.js
@@ -0,0 +1,145 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import { connect } from 'react-redux';
+import {
+  saveConfig,
+  deleteWidget,
+  closeConfigDialog,
+  } from "../core/actions/widget";
+import {
+  makeLoadable,
+  makeLoadingComponent
+} from '../core/utils';
+import SimpleWidgetConfig from '../components/SimpleWidgetConfig';
+import Modal from '../components/Modal';
+
+
+class WidgetConfigDialog extends React.Component {
+
+  propTypes: {
+    widget: PropTypes.object.isRequired,
+    showVisibilitySelect: PropTypes.bool,
+  }
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      widgetConfig: null,
+    };
+    this.handleClose = this.handleClose.bind(this);
+    this.handleWidgetEdited = this.handleWidgetEdited.bind(this);
+    this.handleWidgetDeleted = this.handleWidgetDeleted.bind(this);
+    this.setWidgetConfig = this.setWidgetConfig.bind(this);
+  }
+
+  componentWillReceiveProps(nextProps){
+    if (nextProps.widget.config && (
+        !this.state.widgetConfig ||
+        this.props.widget.idx !== nextProps.widget.idx
+      )) {
+      // Preload the config on initial load and on widget change
+      this.setState({widgetConfig: nextProps.widget.config});
+    }
+  }
+
+  setWidgetConfig(name, value) {
+    this.setState((prevState, props) => {
+      prevState.widgetConfig[name] = value;
+      return {widgetConfig: prevState.widgetConfig};
+    });
+  }
+
+  handleWidgetEdited(e) {
+    e.preventDefault();
+    this.props.dispatch(saveConfig(this.props.widget.idx, this.state.widgetConfig));
+  }
+
+  handleWidgetDeleted(e) {
+    e.preventDefault();
+    this.props.dispatch(deleteWidget(this.props.widget.idx));
+  }
+
+  handleClose(e) {
+    this.props.dispatch(closeConfigDialog());
+  }
+
+  render() {
+    if (!this.props.widget) {
+      return null;
+    }
+    const widgetName = this.props.widget.name;
+    let contents;
+    if (this.props.widget.isReact) {
+      const AsyncComponent = makeLoadable(
+        () => import(`../widgets/${widgetName}/Config`),
+        makeLoadingComponent(
+          "Loading widget configuration...",
+          "Sorry, there was a problem loading the widget configuration."
+        )
+      );
+      contents = (
+        <AsyncComponent
+          widget={this.props.widget}
+          values={this.state.widgetConfig}
+          setConfig={this.setWidgetConfig}
+          />
+      );
+    } else {
+      contents = (
+        <SimpleWidgetConfig
+          widget={this.props.widget}
+          values={this.state.widgetConfig}
+          setConfig={this.setWidgetConfig}
+          />
+      );
+    }
+    const footer = (
+      <div className="d-flex justify-content-end w-100">
+        <button
+          type="button"
+          className="btn btn-danger mr-auto"
+          onClick={this.handleWidgetDeleted}
+          >
+          Remove this widget
+        </button>
+        <button
+          type="button"
+          className="btn btn-secondary ml-3"
+          onClick={this.handleClose}
+          >
+          Close
+        </button>
+        <button
+          type="button"
+          className="btn btn-primary ml-3"
+          onClick={this.handleWidgetEdited}
+          >
+          Save
+        </button>
+      </div>
+    );
+
+    return (
+      <Modal
+        onCloseClicked={this.handleClose}
+        isLarge={this.props.widget.isReact}
+        title={`Configuring widget ${this.props.widget.label}`}
+        footer={footer}
+        >
+        {contents}
+      </Modal>
+    );
+  }
+}
+
+
+const mapStateToProps = (state) => {
+  const confWidgetId = state.ui.widgetConfigDialogOpen;
+  return {
+    widget: (
+      confWidgetId && state.entities.widgets.byId[confWidgetId]
+    ),
+  }
+};
+
+export default connect(mapStateToProps)(WidgetConfigDialog);
diff --git a/hubs/static/client/app/components/WidgetsArea.js b/hubs/static/client/app/components/WidgetsArea.js
new file mode 100644
index 0000000..a23e3df
--- /dev/null
+++ b/hubs/static/client/app/components/WidgetsArea.js
@@ -0,0 +1,90 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import { connect } from 'react-redux';
+import WidgetsColumn from './WidgetsColumn';
+import CobWeb from './CobWeb';
+import WidgetConfigDialog from './WidgetConfigDialog';
+import SSESource from "./SSESource";
+import NotifIcon from "./NotifIcon";
+import Spinner from "./Spinner";
+import { fetchWidgets } from '../core/actions/widgets';
+import "./WidgetsArea.css";
+
+
+class WidgetsArea extends React.PureComponent {
+
+  componentDidMount() {
+    this.props.dispatch(fetchWidgets());
+  }
+
+  render() {
+    if (!this.props.hub.name) {
+      return null;
+    }
+    return (
+      <div className="WidgetsArea">
+        { this.props.widgets.isLoading &&
+          <Spinner />
+        }
+        <div className="row">
+          <div className={`col-md-${this.props.hub.config.left_width}`}>
+
+            { /*
+              First, before the proper widgets.. a cobweb built-in widget.
+              https://pagure.io/fedora-hubs/issue/133
+            */
+              !this.props.editMode &&
+              <CobWeb
+                cause={this.props.hub.config.archived ? "archived" : "old"}
+                mtime={this.props.hub.mtime}
+                />
+            }
+
+            <WidgetsColumn
+              position="left"
+              widgets={
+                this.props.widgets.left.map((widgetIdx) => (
+                  this.props.widgets.byId[widgetIdx]
+                ))
+              }
+              handleWidgetMoved={this.handleWidgetMoved}
+              />
+          </div>
+
+          <div className={`col-md-${this.props.hub.config.right_width}`}>
+            <WidgetsColumn
+              position="right"
+              widgets={
+                this.props.widgets.right.map((widgetIdx) => (
+                  this.props.widgets.byId[widgetIdx]
+                ))
+              }
+              handleWidgetMoved={this.handleWidgetMoved}
+              />
+          </div>
+        </div>
+
+        <WidgetConfigDialog />
+        <SSESource />
+        <NotifIcon />
+      </div>
+    );
+  }
+}
+WidgetsArea.propTypes = {
+  hub: PropTypes.object.isRequired,
+  widgets: PropTypes.object.isRequired,
+  editMode: PropTypes.bool,
+}
+
+
+const mapStateToProps = (state) => {
+  const confWidgetId = state.ui.widgetConfigDialogOpen;
+  return {
+    hub: state.entities.hub,
+    widgets: state.entities.widgets,
+    editMode: state.ui.widgetsEditMode,
+  }
+};
+
+export default connect(mapStateToProps)(WidgetsArea);
diff --git a/hubs/static/client/app/components/WidgetsColumn.js b/hubs/static/client/app/components/WidgetsColumn.js
new file mode 100644
index 0000000..7a4b25c
--- /dev/null
+++ b/hubs/static/client/app/components/WidgetsColumn.js
@@ -0,0 +1,59 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import { connect } from 'react-redux';
+import { moveWidget } from '../core/actions/widget';
+import WidgetsList from './WidgetsList';
+import AddWidget from './AddWidget';
+
+
+class WidgetsColumn extends React.Component {
+
+  propTypes: {
+    position: PropTypes.string.isRequired,
+    widgets: PropTypes.array.isRequired,
+    editMode: PropTypes.bool,
+  }
+
+  constructor(props) {
+    super(props);
+    this.handleWidgetMoved = this.handleWidgetMoved.bind(this);
+  }
+
+  handleWidgetMoved({oldIndex, newIndex}, e) {
+    if (oldIndex === newIndex) {
+      return;
+    }
+    this.props.dispatch(moveWidget(this.props.position, oldIndex, newIndex));
+  }
+
+  render() {
+    return (
+      <div className="WidgetsColumn">
+
+        {this.props.editMode &&
+          <AddWidget
+            position={this.props.position}
+            availableWidgetsUrl={this.props.availableWidgetsUrl}
+            />
+        }
+
+        <div id={`${this.props.position}_widgets`}>
+          <WidgetsList
+            widgets={this.props.widgets}
+            handleWidgetMoved={this.handleWidgetMoved}
+            />
+        </div>
+
+      </div>
+    );
+  }
+}
+
+
+const mapStateToProps = (state) => {
+  return {
+    editMode: state.ui.widgetsEditMode,
+  }
+};
+
+export default connect(mapStateToProps)(WidgetsColumn);
diff --git a/hubs/static/client/app/components/WidgetsList.js b/hubs/static/client/app/components/WidgetsList.js
new file mode 100644
index 0000000..137b120
--- /dev/null
+++ b/hubs/static/client/app/components/WidgetsList.js
@@ -0,0 +1,69 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import { connect } from 'react-redux';
+import {SortableContainer, SortableElement} from 'react-sortable-hoc';
+import Widget from './Widget';
+
+
+class WidgetsList extends React.Component {
+  render() {
+    const WidgetComponent = this.props.component;
+    return (
+      <div className="Widgets">
+        {this.props.widgets.map((widget, index) => (
+          <WidgetComponent
+            key={widget.idx}
+            index={index}
+            widget={widget}
+            />
+        ))}
+      </div>
+    );
+  }
+}
+WidgetsList.propTypes = {
+  widgets: PropTypes.array.isRequired,
+  editMode: PropTypes.bool,
+  component: PropTypes.func,
+}
+WidgetsList.defaultProps = {
+  component: Widget,
+  editMode: false,
+}
+
+
+const SortableWidget = SortableElement(Widget);
+const SortableWidgetList = SortableContainer((props) => (
+  <WidgetsList component={SortableWidget} {...props} />
+));
+
+
+function EditableWidgetsList(props) {
+  if (props.editMode) {
+    return (
+      <SortableWidgetList
+        lockAxis="y"
+        onSortEnd={props.handleWidgetMoved}
+        helperClass="widget--dragged"
+        {...props}
+        />
+      );
+  } else {
+    return (<WidgetsList {...props} />);
+  }
+}
+EditableWidgetsList.propTypes = {
+  editMode: PropTypes.bool,
+}
+EditableWidgetsList.defaultProps = {
+  editMode: false,
+}
+
+
+const mapStateToProps = (state) => {
+  return {
+    editMode: state.ui.widgetsEditMode,
+  }
+};
+
+export default connect(mapStateToProps)(EditableWidgetsList);
diff --git a/hubs/static/client/app/components/feed/Actions.js b/hubs/static/client/app/components/feed/Actions.js
new file mode 100644
index 0000000..7219821
--- /dev/null
+++ b/hubs/static/client/app/components/feed/Actions.js
@@ -0,0 +1,36 @@
+import React from 'react';
+
+
+export default class Actions extends React.Component {
+
+  render() {
+    var buttonProps = {
+      id: `save-${this.props.item.dom_id}`,
+      className: "btn btn-sm ",
+    };
+    var buttonText;
+
+    if (this.props.item.saved) {
+      buttonProps.className += "btn-success";
+      buttonProps.onClick = () => {
+        this.props.handleUnsave(this.props.item);
+      };
+      buttonText = "Saved";
+    } else {
+      buttonProps.className += "btn-primary";
+      buttonProps.onClick = () => {
+        this.props.handleSave(this.props.item);
+      };
+      buttonText = "Save";
+    }
+
+    return (
+      <div className="float-right">
+        <button {...buttonProps}>
+          {buttonText}
+        </button>
+      </div>
+    );
+  }
+
+}
diff --git a/hubs/static/client/app/components/feed/Feed.js b/hubs/static/client/app/components/feed/Feed.js
new file mode 100644
index 0000000..338eb2f
--- /dev/null
+++ b/hubs/static/client/app/components/feed/Feed.js
@@ -0,0 +1,47 @@
+import React from 'react';
+import PropTypes from 'prop-types';
+import {
+  defineMessages,
+  FormattedMessage,
+  } from 'react-intl';
+import Panel from './Panel';
+import "./Feed.css";
+
+
+const messages = defineMessages({
+  no_items: {
+    id: "hubs.components.feed.no_items",
+    defaultMessage: "No items yet.",
+  },
+});
+
+
+export default class Feed extends React.Component {
+
+  render() {
+    var items = this.props.items || [];
+    items = items.map((item, idx) => {
+      return (
+        <Panel item={item} {...this.props} key={item.dom_id} />
+        );
+    });
+    return (
+      <div className="Feed">
+        { (items.length == 0 && this.props.loaded) ?
+          <FormattedMessage {...messages.no_items} tagName="i" />
+          :
+          items
+        }
+      </div>
+    );
+  }
+
+}
+
+
+Feed.propTypes = {
+  loaded: PropTypes.bool,
+};
+Feed.defaultProps = {
+  loaded: true,
+};
diff --git a/hubs/static/client/app/components/feed/Icon.js b/hubs/static/client/app/components/feed/Icon.js
new file mode 100644
index 0000000..4ae2f25
--- /dev/null
+++ b/hubs/static/client/app/components/feed/Icon.js
@@ -0,0 +1,18 @@
+import React from 'react';
+
+export default class Icon extends React.Component {
+  render() {
+    return (
+      <a href={this.props.item.link ? this.props.item.link : '#'}
+         target="_blank"
+         className="d-flex align-self-start mr-3"
+         >
+        <img
+          alt="User avatar"
+          className="square-32 img-circle"
+          src={this.props.item.secondary_icon}
+        />
+      </a>
+    );
+  }
+}
